com.ihr.xbrl.dts

## Class FactsColumn

- java.lang.Object
- - java.util.Dictionary<K,V>
  - - java.util.Hashtable<FactUseItem,XBRLFactItem>
    - - com.ihr.xbrl.dts.FactsColumn

- All Implemented Interfaces:
    java.io.Serializable, java.lang.Cloneable, java.util.Map<FactUseItem,XBRLFactItem>

      public class FactsColumn
      extends java.util.Hashtable<FactUseItem,XBRLFactItem>

  This is a class representing all facts in a logical column.
  Author:
    Ignacio
  See Also:
    Serialized Form

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `FactsColumn(ColumnPeriod period)` Instantiates a new facts column.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `addContext(XBRLContext ctx, int use)` Adds a context to this FactsColumn.
    `void` | `delContext(XBRLContext ctx)` Del context.
    `XBRLFactItem` | `get(java.lang.Object key)`
    `java.util.Collection<XBRLContext>` | `getContexts(boolean bIncludeEmpty)` Gets the contexts.
    `XBRLContext` | `getContexts(XBRLItem.PeriodType periodType, int use)` Returns the most used XBRLContext object in this column filtered by the period type and FactUse.
    `ColumnPeriod` | `getPeriod()` Gets the period.
    `FactUseItem` | `getRowKey(XBRLFactItem fact)` For a fact item added to this FactsColumn this method returns the assigned row number.
    `int` | `getRowNumber(XBRLFactItem fact)` For a fact item added to this FactsColumn this method returns the assigned row number.
    `XBRLFactItem` | `put(FactUseItem key, XBRLFactItem value)`
    `XBRLFactItem` | `remove(java.lang.Object key)`

    - ### Methods inherited from class java.util.Hashtable

      `clear, clone, contains, containsKey, containsValue, elements, entrySet, equals, hashCode, isEmpty, keys, keySet, putAll, size, toString, values`

    - ### Methods inherited from class java.lang.Object

      `getClass, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### FactsColumn

          public FactsColumn(ColumnPeriod period)

      Instantiates a new facts column.
      Parameters:
        `period` - the period

  - ### Method Detail

    - #### getPeriod

          public ColumnPeriod getPeriod()

      Gets the period.
      Returns:
        the period

    - #### getContexts

          public java.util.Collection<XBRLContext> getContexts(boolean bIncludeEmpty)

      Gets the contexts.
      Parameters:
        `bIncludeEmpty` - the b include empty
      Returns:
        the contexts

    - #### getContexts

          public XBRLContext getContexts(XBRLItem.PeriodType periodType,
                                int use)

      Returns the most used XBRLContext object in this column filtered by the period type and FactUse.
      Parameters:
        `periodType` - int XBRLItem.DURATION or XBRLItem.INSTANT
        `use` - constant indicating beginning of period, end of period or normal usage.
      Returns:
        XBRLContext

    - #### put

          public XBRLFactItem put(FactUseItem key,
                         XBRLFactItem value)

      Specified by:
        `put` in interface `java.util.Map<FactUseItem,XBRLFactItem>`
      Overrides:
        `put` in class `java.util.Hashtable<FactUseItem,XBRLFactItem>`

    - #### getRowNumber

          public int getRowNumber(XBRLFactItem fact)

      For a fact item added to this FactsColumn this method returns the assigned row number.
      Parameters:
        `fact` - the fact
      Returns:
        the row number

    - #### getRowKey

          public FactUseItem getRowKey(XBRLFactItem fact)

      For a fact item added to this FactsColumn this method returns the assigned row number.
      Parameters:
        `fact` - the fact
      Returns:
        the row key

    - #### addContext

          public void addContext(XBRLContext ctx,
                        int use)

      Adds a context to this FactsColumn. Normally, when a fact item is associated with the FactColumn the context is added to the FactsColumn automatically. This method is for the special cases where a context is created before an item is created.
      Parameters:
        `ctx` - the ctx
        `use` - the use

    - #### delContext

          public void delContext(XBRLContext ctx)

      Del context.
      Parameters:
        `ctx` - the ctx

    - #### get

          public XBRLFactItem get(java.lang.Object key)

      Specified by:
        `get` in interface `java.util.Map<FactUseItem,XBRLFactItem>`
      Overrides:
        `get` in class `java.util.Hashtable<FactUseItem,XBRLFactItem>`

    - #### remove

          public XBRLFactItem remove(java.lang.Object key)

      Specified by:
        `remove` in interface `java.util.Map<FactUseItem,XBRLFactItem>`
      Overrides:
        `remove` in class `java.util.Hashtable<FactUseItem,XBRLFactItem>`